﻿----------------------------------------------------------------------------
-- ©Copyright: ViperGTS96®--------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------
realDirtColor_LoadColorEvent = {};
realDirtColorLoadColorEvent_mt = Class(realDirtColor_LoadColorEvent, Event);
InitEventClass(realDirtColor_LoadColorEvent,"realDirtColor_LoadColorEvent");

function realDirtColor_LoadColorEvent:emptyNew()
    local self = Event.new(realDirtColorLoadColorEvent_mt);
    self.className = "realDirtColor_LoadColorEvent";
    return self;
end;

function realDirtColor_LoadColorEvent:new(vehicle, r,g,b, curIndex,prevIndex, wheelIndex)
	local self = realDirtColor_LoadColorEvent.emptyNew()
    self.vehicle = vehicle;
    self.r = r;
    self.g = g;
    self.b = b;
    self.curIndex = curIndex;
    self.prevIndex = prevIndex;
    self.wheelIndex = wheelIndex;
    return self;
end;

function realDirtColor_LoadColorEvent:readStream(streamId,connection)
    self.vehicle = NetworkUtil.readNodeObject(streamId);
    self.r =  streamReadFloat32(streamId);
    self.g =  streamReadFloat32(streamId);
    self.b =  streamReadFloat32(streamId);
    self.curIndex =  streamReadFloat8(streamId);
    self.prevIndex =  streamReadFloat8(streamId);
    self.wheelIndex =  streamReadInt8(streamId);
    self:run(connection);
end;

function realDirtColor_LoadColorEvent:writeStream(streamId,connection)
    NetworkUtil.writeNodeObject(streamId,self.vehicle);
    streamWriteFloat32(streamId,self.r);
    streamWriteFloat32(streamId,self.g);
    streamWriteFloat32(streamId,self.b);
    streamWriteFloat8(streamId,self.curIndex);
    streamWriteFloat8(streamId,self.prevIndex);
    streamWriteInt8(streamId,self.wheelIndex);
end;

function realDirtColor_LoadColorEvent:run(connection)
    self.vehicle:rdcSetLoadedColorEvent(self.r,self.g,self.b, self.curIndex,self.prevIndex, self.wheelIndex, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(realDirtColor_LoadColorEvent:new(self.vehicle,self.r,self.g,self.b, self.curIndex,self.prevIndex, self.wheelIndex),nil,connection,self.vehicle);
    end;
end;

function realDirtColor_LoadColorEvent.sendEvent(vehicle, r,g,b, curIndex,prevIndex, wheelIndex,noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(realDirtColor_LoadColorEvent:new(vehicle, r,g,b, curIndex,prevIndex, wheelIndex),nil,nil,vehicle);
        else
            g_client:getServerConnection():sendEvent(realDirtColor_LoadColorEvent:new(vehicle, r,g,b, curIndex,prevIndex, wheelIndex));
        end;
    end;
end;

 function realDirtColor:rdcSetLoadedColorEvent(r,g,b, curIndex,prevIndex, wheelIndex, noEventSend)
	realDirtColor_LoadColorEvent.sendEvent(self, r,g,b, curIndex,prevIndex, noEventSend);
	if not self.isServer then
		if self.spec_realDirtColor ~= nil then
			local spec = self.spec_realDirtColor;
			curIndex, prevIndex = self:floorRDCColorIndex(curIndex, prevIndex);
			if wheelIndex < 1 then
				spec.currentDirtColor = curIndex;
				spec.previousDirtColor = prevIndex;
				local _,_,targetRDColor = self:getNewColorIndex(0, 0, curIndex, spec.targetRDColor);
				spec.targetRDColor = targetRDColor;
				for _, part in pairs(spec.bodypart) do
					setShaderParameter(part, "dirtColor", r, g, b, 0, false);
				end;
			else
				if self.spec_wheels ~= nil and self.spec_wheels.wheels ~= nil and #self.spec_wheels.wheels ~= 0 then
					local wheel = self.spec_wheels.wheels[wheelIndex];
					if wheel.bodypart ~= nil then
						for _, part in pairs(wheel.bodypart) do
							setShaderParameter(part, "dirtColor", r, g, b, 0, false);
						end;
					end;
					wheel.currentDirtColor = curIndex;
					wheel.previousDirtColor = prevIndex;
					local _,_,targetRDColor = self:getNewColorIndex(0, 0, curIndex, wheel.targetRDColor);
					wheel.targetRDColor = targetRDColor;
				end;
			end;
		end;
	end;
end;